/*Esta es una libreria para el MODDISPLAY de Intesc

 */

//Variables de la libreria
int display[10] = {192,249,164,176,153,146,130,248,128,144}; //Arreglo para display de 7s nodo comn
int index = 0;  //Variable para separar las unidades, las decenas, las centenas y millares

//Declaracin de pines del MOD DISPLAY -- MODIFICAR AL GUSTO SI ES NECESARIO
#define MILLARES    LATDbits.LD7
#define CENTENAS    LATDbits.LD6
#define DECENAS     LATDbits.LD5
#define UNIDADES    LATDbits.LD4

//Puerto para mostrar la numeracion - CAMBIAR AL GUSTO SI ES NECESARIO
#define PUERTO      LATB
/* * Conexiones entre el MOD DISPLAY  y la tarjeta Miuva
 * EN CASDO DE CAMBIAR DE PUERTO, EL PIN A DEBE CONECTARSE AL PIN 0 DEL PUERTO EN CUESTION
 * A ----- B0 ------ D0 ----- A0
 * B ----- B1 ------ D1 ----- A1
 * C ----- B2 ------ D2 ----- A2
 * D ----- B3 ------ D3 ----- A3
 * E ----- B4 ------ D4 ----- A4
 * R ----- B5 ------ D5 ----- A5
 * G ----- B6 ------ D6 ----- A6
 * DP ---- B7 ------ D7 ----- A7
*/

//Funcion para el multiplexado de los displays
void LAT_MUX(int w, int x, int y, int z){
    UNIDADES = w; //Definimos el pin RD4 para mostrar los millares
    DECENAS = x; //Definimos el pin RD5 para mostrar las centenas
    CENTENAS = y; //Definimos el pin RD6 para mostrar las decenas
    MILLARES = z; //Definimos el pin RD7 para mostrar las unidades 
}

//Fucion para mostrar un numero entero de hasta 4 digitos
    void DISPLAY(int numero){
        if (numero < 10){  //Primer estructura if: para mostrar numeros menores a 10
            LAT_MUX(1,1,1,1); //Apagamos todos los transistores del multiplexado
            PUERTO = display[numero]; //Enviamos el nmero hacia el canal del display
            LAT_MUX(0,1,1,1); //Encendemos el transistor del display de las unidades
            __delay_us(100); //El display permanece encendido por 100 us
            LAT_MUX(1,1,1,1); //Apagamos todos los transistores del multiplexado
            PUERTO = display[0]; //Enviamos un cero al display
            LAT_MUX(1,0,1,1); //Encendemos el transistor del display de las decenas
            __delay_us(100); //El display permanece encendido por 100 us
            LAT_MUX(1,1,1,1); //Apagamos todos los trnasistores del multiplexado
            PUERTO = display[0]; //Enviamos un cero al display
            LAT_MUX(1,1,0,1); //Encendemos el transistor del display de las centenas
            __delay_us(100); //El display permanece encendido por 100 us
            LAT_MUX(1,1,1,1); //Apagamos todos los trnasistores del multiplexado
            PUERTO = display[0]; //Enviamos un cero al display
            LAT_MUX(1,1,1,0); //Encendemos el transistor del display de las unidades de millar
            __delay_us(100); //El display permanece encendido por 100 us
        }
        else if (numero > 9 && numero <100 ){ //Segunda estrictura if: para mostrar numeros mayores a 9 y menores que 100
            LAT_MUX(1,1,1,1); //Apagamos todos los trnasistores del multiplexado
            index = numero%10; //El modulo de un numero de dos digitos es el nmero de las unidades
            PUERTO = display[index]; //Enviamos las unidades al display
            LAT_MUX(0,1,1,1); //Encendemos el transistor del display de las unidades
            __delay_us(100); //El display permanece encendido por 100 us
            LAT_MUX(1,1,1,1); //Apagamos todos los trnasistores del multiplexado
            index = numero/10; //Al dividir un numero de dos digitos entre 10, obtenemos el digito de las decenas
            PUERTO = display[index]; //Enviamos el digito de las decenas al display
            LAT_MUX(1,0,1,1); //Encendemos el transistor del display de las decenas
            __delay_us(100); //El display permanece encendido por 100 us
            LAT_MUX(1,1,1,1); //Apagamos todos los trnasistores del multiplexado
            PUERTO = display[0]; //Enviamos un cero al display
            LAT_MUX(1,1,0,1); //Encendemos el transistor del display de las centenas
            __delay_us(100); //El display permanece encendido por 100 us
            LAT_MUX(1,1,1,1); //Apagamos todos los trnasistores del multiplexado
            PUERTO = display[0]; //Enviamos un cero al display
            LAT_MUX(1,1,1,0); //Encendemos el transistor del display de las unidades de millar
            __delay_us(100); //El display permanece encendido por 100 us
        }
        else if (numero > 99 && numero < 1000){ //Tercera estrictura if: para mostrar numeros mayores a 99 y menores que 1000
            LAT_MUX(1,1,1,1); //Apagamos todos los trnasistores del multiplexado
            index = numero%10; //El modulo de un numero de dos digitos es el nmero de las unidades
            PUERTO = display[index]; //Enviamos las unidades al display
            LAT_MUX(0,1,1,1); //Encendemos el transistor del display de las unidades
            __delay_us(100); //El display permanece encendido por 100 us
            LAT_MUX(1,1,1,1); //Apagamos todos los trnasistores del multiplexado
            index = numero/10; //Dvidimos un numero de tres digitos entre 10
            index = index%10; //El modulo del numero anterior, representa el valor de las decenas
            PUERTO = display[index]; //Enviamos el digito de las decenas al display
            LAT_MUX(1,0,1,1); //Encendemos el transistor del display de las decenas
            __delay_us(100); //El display permanece encendido por 100 us
            LAT_MUX(1,1,1,1); //Apagamos todos los trnasistores del multiplexado
            index = numero/100; //Al dividir un numero de tres digitos, obtenemos el valor de las centenas
            PUERTO = display[index]; //Enviamos el digito de las centenas al dispaly
            LAT_MUX(1,1,0,1); //Encendemos el transistor del display de las centenas
            __delay_us(100); //El display permanece encendido por 100 us
            LAT_MUX(1,1,1,1); //Apagamos todos los trnasistores del multiplexado
            PUERTO = display[0]; //Enviamos un cero al display
            LAT_MUX(1,1,1,0); //Encendemos el transistor del display de las unidades de millar
            __delay_us(100); //El display permanece encendido por 100 us
        }
        else if (numero > 999 && numero < 10000){ //Estructura if para mostrar numeros mayores 999 y menores 10000
            LAT_MUX(1,1,1,1); //Apagamos todos los trnasistores del multiplexado
            index = numero%10; //Calculamos el modulo de un numero de 4 digitos que representa las unidades
            PUERTO = display[index]; //Enviamos el digito al display
            LAT_MUX(0,1,1,1); //Encendemos el transistor del display de las unidades
            __delay_us(100); //El display permanece encendido por 100 us
            LAT_MUX(1,1,1,1); //Apagamos todos los trnasistores del multiplexado
            index = numero/10; //Dividimos un numero de 4 digitos entre 10
            index = index%10; //El modulo de ese numero representa las decenas
            PUERTO = display[index]; //Enviamos las decenas al dislay
            LAT_MUX(1,0,1,1); //Encendemos el transistor del display de las decenas
            __delay_us(100); //El display permanece encendido por 100 us
            LAT_MUX(1,1,1,1); //Apagamos todos los trnasistores del multiplexado
            index = numero/100; //Dividimos ese numero entre 100
            index = index%10; //El modulo de ese numero representa las centenas
            PUERTO = display[index]; //Enviamos las centenas al display
            LAT_MUX(1,1,0,1); //Encendemos el transistor del display de las centenas
            __delay_us(100); //El display permanece encendido por 100 us
            LAT_MUX(1,1,1,1); //Apagamos todos los trnasistores del multiplexado
            index = numero/1000; //Dividimos el numero entre 1000, y representa a las unidades de millar
            PUERTO = display[index]; //Enviamos las unidades de millar al display
            LAT_MUX(1,1,1,0); //Encendemos el transistor del display de las unidades de millar
            __delay_us(100); //El display permanece encendido por 100 us
        }
    }
    
    //Funcion para mostrar un digito
    void DIGITO(int a, int b) {
        PUERTO = display[a]; //Enviamos el nmero hacia el canal del display
        if (b == 4){
            LAT_MUX(1,1,1,0);
            __delay_us(100);
            LAT_MUX(1,1,1,1); //Apagamos todos los trnasistores del multiplexado
            __delay_us(100);
        }
        else if (b == 3){
            LAT_MUX(1,1,0,1);
            __delay_us(100);
            LAT_MUX(1,1,1,1); //Apagamos todos los trnasistores del multiplexado
            __delay_us(100);
        }
        else if (b == 2){
            LAT_MUX(1,0,1,1);
            __delay_us(100);
            LAT_MUX(1,1,1,1); //Apagamos todos los trnasistores del multiplexado
            __delay_us(100);
        }
        else if (b == 1){
            LAT_MUX(0,1,1,1);
            __delay_us(100);
            LAT_MUX(1,1,1,1); //Apagamos todos los trnasistores del multiplexado
            __delay_us(100);
        }
    }